#
# spec file for package cvs (Version 1.12.12)
#
# Copyright (c) 2011 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild


Name:           cvs
BuildRequires:  postfix update-desktop-files
License:        GPL v2 or later; LGPL v2.1 or later
Group:          Development/Tools/Version Control
Url:            http://www.cvshome.org/
AutoReqProv:    on
Version:        1.12.12
Release:        19.6.4
Summary:        Concurrent Versions System
Requires:       /bin/mktemp, /usr/bin/csh
Source:         %name-%version.tar.bz2
Source1:        http://www.does-not-exist.org/roessler/cvslock-0.2.tar.gz
Source2:        xinetd.conf
Source3:        cvs.sh
Source4:        cvs.csh
Source10:       http://cvsbook.red-bean.com/OpenSourceDevWithCVS_2E.tar.gz
Source11:       cvs.desktop
Patch:          cvs.diff
Patch2:         diff-k.possible.patch
Patch5:         fix_sigpipe_flowcontrol.diff
#Patch6:       allow_trailing_dir_slash.diff
#Patch7:       use_system_zlib.diff
Patch8:         use_vitmp.diff
Patch10:        new-sort-option.diff
Patch11:        cvs-1.11.9-nocsh.patch
Patch16:        cvs_readd_l_option.diff
Patch17:        silence_option_r_warning.diff
Patch18:        silence_old_format_strings.diff
Patch19:        cvs-1.12.9-null.patch
Patch20:        cvs-format.patch
Patch21:        useless-asnprintf.diff
Patch22:        cvs-1.12.12_cvsbug-tmp.diff
Patch23:        cvs-1.12.12-rcsfile-sanity.diff
Patch24:        cvs-1.12.12-gcc-4.1.diff
Patch25:        cvs-wrong_parameter.diff	
Patch26:        fix_path_list_prefixed.diff
PreReq:         %install_info_prereq 
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
CVS is a front-end to the Revision Control System included in the
standard Linux distributions. PCL-CVS, an Emacs front-end for CVS, is
also included.



Authors:
--------
    Brian Berliner <berliner@sun.com>
    Jeff Polk <polk@bsdi.com>

%package doc
License:        GPL v2 or later; LGPL v2.1 or later
Summary:        Open Source Development with CVS, 2nd Edition Book
Group:          Development/Tools/Version Control

%description doc
The complete Open Source Development with CVS, 2nd Edition book.



Authors:
--------
    Brian Berliner <berliner@sun.com>
    Jeff Polk <polk@bsdi.com>

%prep
%setup -q -a 1 -a 10
%patch
%patch2
%patch5
#%patch7 -p1
%patch8 -p1
%patch10
%patch11 -p1
%patch16
%patch17
%patch18
%patch19
%patch20 -p1
%patch21
%patch22 -p1
%patch23
%patch24
%patch25
%patch26

%build
aclocal -I m4
autoconf
export CFLAGS="$RPM_OPT_FLAGS -pipe" 
./configure \
   --with-external-zlib \
   --prefix=/usr \
   --infodir=%_infodir \
   --mandir=%_mandir \
   --libdir=%_libdir
cd cvslock-* 
./configure \
   --prefix=/usr \
   --mandir=%_mandir \
   --libdir=%_libdir
cd -
make
cd cvslock-*
make
cd -

%install
make DESTDIR=$RPM_BUILD_ROOT install install-info
mkdir -p $RPM_BUILD_ROOT/etc/profile.d
install -m 0644 %SOURCE3 %SOURCE4 $RPM_BUILD_ROOT/etc/profile.d
# hack to avoid csh in requires
chmod 644 $RPM_BUILD_ROOT/usr/share/cvs/contrib/sccs2rcs
mkdir -p $RPM_BUILD_ROOT/etc/xinetd.d
cp -ai $RPM_SOURCE_DIR/xinetd.conf $RPM_BUILD_ROOT/etc/xinetd.d/cvs
#
# install cvslock
#
cd cvslock-* 
make DESTDIR=$RPM_BUILD_ROOT install
cd -
#
# documentation
#
mkdir -p $RPM_BUILD_ROOT/usr/share/susehelp/meta/Development/Tools/
mkdir -p $RPM_BUILD_ROOT/%_defaultdocdir/%name/
install -m 0644 %SOURCE11 \
        $RPM_BUILD_ROOT/usr/share/susehelp/meta/Development/Tools/
%suse_update_desktop_file $RPM_BUILD_ROOT/usr/share/susehelp/meta/Development/Tools/cvs.desktop
install -m 0644 */OpenSourceDevWithCVS_2E.pdf \
        $RPM_BUILD_ROOT/%_defaultdocdir/%name/

%post doc
%install_info --info-dir=%{_infodir} %{_infodir}/%{name}.info.gz
%install_info --info-dir=%{_infodir} %{_infodir}/%{name}client.info.gz

%postun doc
%install_info_delete --info-dir=%{_infodir} %{_infodir}/%{name}.info.gz
%install_info_delete --info-dir=%{_infodir} %{_infodir}/%{name}client.info.gz

%files
%defattr(-,root,root)
%dir /usr/share/cvs
%dir /usr/share/cvs/contrib
%config(noreplace) /etc/xinetd.d/cvs
%config(noreplace) /etc/profile.d/cvs.sh
%config(noreplace) /etc/profile.d/cvs.csh
/usr/bin/cvs
/usr/bin/cvsbug
/usr/bin/rcs2log
/usr/bin/cvslock
/usr/share/cvs/contrib/clmerge
/usr/share/cvs/contrib/cln_hist
/usr/share/cvs/contrib/commit_prep
/usr/share/cvs/contrib/cvs2vendor
/usr/share/cvs/contrib/cvs_acls
/usr/share/cvs/contrib/debug_check_log
/usr/share/cvs/contrib/log
/usr/share/cvs/contrib/log_accum
/usr/share/cvs/contrib/mfpipe
/usr/share/cvs/contrib/newcvsroot
/usr/share/cvs/contrib/pvcs2rcs
/usr/share/cvs/contrib/rcs2log
/usr/share/cvs/contrib/rcslock
/usr/share/cvs/contrib/rcs-to-cvs
/usr/share/cvs/contrib/README
/usr/share/cvs/contrib/sandbox_status
/usr/share/cvs/contrib/validate_repo
%attr(755,root,root) /usr/share/cvs/contrib/sccs2rcs
%doc %{_mandir}/man1/cvs.1.gz
%doc %{_mandir}/man1/cvslock.1.gz
%doc %{_mandir}/man5/cvs.5.gz
%doc %{_mandir}/man8/cvsbug.8.gz

%files doc
%defattr(-,root,root)
%dir %_defaultdocdir/%name
%dir /usr/share/susehelp
%dir /usr/share/susehelp/meta
%dir /usr/share/susehelp/meta/Development
%dir /usr/share/susehelp/meta/Development/Tools
%doc %_infodir/cvs.info-*.gz
%doc %_infodir/cvs.info.gz
%doc %_infodir/cvsclient.info-*.gz
%doc %_infodir/cvsclient.info.gz
%doc /usr/share/cvs/contrib/intro.doc
%doc %_defaultdocdir/%name/OpenSourceDevWithCVS_2E.pdf
%doc /usr/share/susehelp/meta/Development/Tools/cvs.desktop

%changelog
* Wed Jan  5 2011 dmueller@suse.de
- fix logic when handling relative paths (bnc#644669)
* Wed Jul 22 2009 sf@suse.de
- added cvs-wrong_parameter.diff (bnc #491633)
* Wed Jan 25 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Fri Nov  4 2005 od@suse.de
- corrected fix of type punned pointer warning in ls.c:327
* Mon Oct 31 2005 od@suse.de
- fix type punned pointer warning in ls.c:327
* Thu Oct 20 2005 od@suse.de
- fix "cvs up" segfault on corrupt repository file (#129681)
* Tue Aug 30 2005 lnussel@suse.de
- fix /tmp issue in cvsbug (#59450)
* Thu Aug 11 2005 schwab@suse.de
- Don't use [v]asnprintf.
* Wed Aug 10 2005 hvogel@suse.de
- update to version 1.12.12 to get rid of bugs of locales that use
  "GMT" for one of their UTC offsets.  [Bug #86422]
* Sun Feb  6 2005 meissner@suse.de
- added format string markup for 2 functions
* Mon Jan 31 2005 adrian@suse.de
- update to version 1.12.11
* Mon Jan 24 2005 meissner@suse.de
- 0 -> NULL for 1 execl, fixed return type of a
  function.
* Fri Aug 20 2004 adrian@suse.de
- update to version 1.12.9
- remove obsolete security patches
* Fri Jun  4 2004 adrian@suse.de
- update last patch to fix WinCVS support (20040521 version)
- new krahmer+esser security fix for (#39773)
  * error_prog_name "double-free()" (SE)
    CAN-2004-0416
  * argument integer overflow (SK)
    CAN-2004-0417
  * serve_notify() out of bound writes (SK)
    CAN-2004-0418
* Mon May 24 2004 adrian@suse.de
- update to version 1.12.7
  * cleanup obsolete patches
  all work made by Dirk Mueller
* Mon May  3 2004 adrian@suse.de
- expoit-fix for malformed Entry lines. This can be exploited via
  a buffer overflow (#39773)
* Tue Apr 20 2004 adrian@suse.de
- update to cvslock 0.2
- add the cvs book from red-bean into new subpackage -doc
- general cleanup
* Sat Apr 17 2004 mmj@suse.de
- Fix typepunning
* Thu Mar 25 2004 mmj@suse.de
- Add postfix to # neededforbuild
* Mon Mar 22 2004 adrian@suse.de
- apply security fix from Derek
  * CVS pserver client side exploit (#36659)
* Sat Mar 13 2004 adrian@suse.de
- update to new version 1.11.14
  (fixes #35890)
* Thu Jan  8 2004 adrian@suse.de
- update to new version 1.11.11
* Fri Dec 12 2003 fehr@suse.de
- update to new version 1.11.10
* Tue Nov 18 2003 meissner@suse.de
- norootforbuild.
- no longer require tcsh, patch configure.in to
  fall back to /usr/bin/csh directly.
* Thu Oct 16 2003 fehr@suse.de
- update to new version 1.11.9
* Wed Aug 13 2003 fehr@suse.de
- provide /etc/profile.d/cvs.{sh,csh} and make cvs use ssh as
  default (#28702)
* Mon Jul 14 2003 fehr@suse.de
- update to new version 1.11.6
* Wed Jul  9 2003 fehr@suse.de
- use new parameters for sort (#26448)
* Fri May 23 2003 fehr@suse.de
- adopt patches for tmp-race fixes and vitmp usage from OpenWall
  Project
- use zlib from system instead of sources provided with cvs
* Thu Apr 24 2003 ro@suse.de
- fix install_info --delete call and move from preun to postun
* Wed Apr 16 2003 coolo@suse.de
- use BuildRoot
* Wed Mar  5 2003 fehr@suse.de
- add missing file /etc/xinetd.d/cvs (#24671)
* Fri Feb  7 2003 fehr@suse.de
- Use %%install_info macro
* Fri Jan 31 2003 fehr@suse.de
- fix race that may lead to aborted checkouts of large files
  (fix_sigpipe_flowcontrol.diff, #23178)
- allow trailing slashes on directories (e.g. cvs up src/)
  (allow_trailing_dir_slash.diff, #13165)
* Wed Jan 22 2003 fehr@suse.de
- make the feature Checkin-prog/Update-prog configurable
  (default is off)
- update to version 1.11.5
* Mon Jan 20 2003 fehr@suse.de
- disable the commands Checkin-prog/Update-prog in cvs server
  decision was made by SuSE security team (security@suse.de)
* Thu Jan 16 2003 fehr@suse.de
- update to cvs version 1.11.4
- add a patch that fixes a possible double free in cvs server
* Sat Feb 23 2002 kukuk@suse.de
- Don't require tcsh [Bug #13424]
* Fri Feb  8 2002 draht@suse.de
- added patch cvs-1.11.1p1-zlib-zfree.dif against duplicate calls
  of free() in zlib
* Fri Dec 14 2001 fehr@suse.de
- update to new version 1.11.1p1
* Tue May  8 2001 mfabian@suse.de
- bzip2 sources
* Mon Mar 19 2001 fehr@suse.de
- add diff-k.possible.patch which fixes problem when using
  cvs diff -k.. (#6653)
* Fri Feb  9 2001 schwab@suse.de
- Ignore $HOME when running as server (#6293).
* Tue Jan 16 2001 werner@suse.de
- Make last security patch smarter: Ignore not existing temp files
* Wed Jan 10 2001 werner@suse.de
- Add temp file patch of Olaf Kirch
* Mon Sep 25 2000 fehr@suse.de
- changed to new version 1.11
* Fri Aug 25 2000 fehr@suse.de
- changed to new version 1.10.8
* Tue Jul 11 2000 fehr@suse.de
- add tcsh to needforbuild to fix a csh-dependet script
* Mon Mar 13 2000 ro@suse.de
- fixed possible segfault
* Fri Feb 25 2000 kukuk@suse.de
- Move /usr/{info,man} -> /usr/share/{info,man}
* Mon Sep 13 1999 bs@suse.de
- ran old prepare_spec on spec file to switch to new prepare_spec.
* Fri Sep  3 1999 fehr@suse.de
- changed to version 1.10.7
* Fri Aug 27 1999 fehr@suse.de
- added cvslock package
* Tue Jul 20 1999 florian@suse.de
- update to 1.10.6, add server patch
* Fri Feb 19 1999 uli@suse.de
- update 1.9.28 -> 1.10.5
- eliminated Makefile.Linux
* Thu Jul 23 1998 werner@suse.de
- use mktemp
* Thu Jul 16 1998 florian@suse.de
- update to version 1.9.28
* Wed Jul 15 1998 werner@suse.de
- Fix possible exploit of rcs2log.sh
* Mon Mar  2 1998 florian@suse.de
- update to version 1.9.24
* Fri Oct 10 1997 florian@suse.de
- update to version 1.9.16
* Wed Apr 30 1997 florian@suse.de
- update to version 1.9.8
* Sun Apr 13 1997 florian@suse.de
- update to new version 1.9.2
